{-# LANGUAGE DatatypeContexts #-}

module TypeClasses where

{-- parametric polymorphism --}
f :: a -> b -> a
--f a _ = a
--f = \x -> \y -> x
f = undefined

length' :: [a] -> Int
length' []     = 0
length' (_:xs) = 1 + length' xs

{-- ad hoc --}
class Person a where
  name  :: a -> String
  age   :: a -> Int
  docId :: a -> Int

data Student =
  Student String
          Int
          Int

data Teacher = Teacher
  { tName :: String
  , tAge  :: Int
  , passport :: Int
  }

instance Person Student where
  name (Student name _ _) = name
  age (Student _ age _)   = age
  docId (Student _ _ dId) = dId

instance Person Teacher where
  name  = tName
  age   = tAge
  docId = passport

theSameAge :: (Person a, Person b) => a -> b -> Bool
theSameAge a b = age a == age b

data (Person a) =>
     Employee a = Employee -- GADT best practice for this
  { person :: a
  , salary :: Integer
  }

data NotShow =
  NotShow
  deriving (Eq, Show)

data St2
  = St2 NotShow
  | St22 Int
  deriving (Eq, Show)

class Eq' a where
  (=!=) :: a -> a -> Bool
  (/!=) :: a -> a -> Bool
  a =!= b = not (a /!= b)
  a /!= b = not (a =!= b)
  {-# MINIMAL (=!=) | (/!=) #-}

data List a
  = Nil --[]
  | Cons a (List a) -- (:) 1:2:[]

instance (Show a) => Show (List a) where
  show Nil = "[]"
  show (Cons x xs) = show x ++ ":" ++ show xs

data DE
  = D0
  | D1
  | D2
  deriving (Show)

instance Enum DE where
  toEnum 0 = D0
  toEnum 1 = D1
  toEnum 2 = D2
  fromEnum D0 = 0
  fromEnum D1 = 1
  fromEnum D2 = 2
  enumFrom x = enumFromTo x D2

instance Bounded DE where
  minBound = D0
  maxBound = D2
